-- Lesson: 	Stocasticity - Some changes are deterministis. 
--			There may be different outcomes for equal conditions.
-- Author:	Tiago Carneiro

-----------------------------------------------------------------
-- PARAMETER
-----------------------------------------------------------------

FINAL_TIME = 1000 -- try 100 (just to see the curve shape)	1000
GROWTH_RATE =  0.3 
SUPPORT_CAPACITY = 100
CHANGE_PROBABILITY = 0.5  -- try  0   0.1  0.5  0.7 	1.0

-----------------------------------------------------------------
-- MODEL
-----------------------------------------------------------------

rand = Random( )
countChange = 0

function change( stockPast )
	
	if ( rand:number(0,1) < CHANGE_PROBABILITY  ) then
		countChange = countChange + 1 
		return GROWTH_RATE * stockPast * ( 1 - stockPast/SUPPORT_CAPACITY )
	end

	return 0 
end 

ag = Agent{
	stock  		= 10,
	execute		= function( self )
		self.stock = self.stock + change( self.stock ) 
	end
}

-----------------------------------------------------------------
-- SIMULATION
-----------------------------------------------------------------

obs = Observer{subject = ag, type = "chart", attributes = {"stock"} }

for t = 1, FINAL_TIME do

	ag:execute();
	--print( ag.stock )
	
	ag:notify(t)
	
end
print("Change percentual:", (countChange/FINAL_TIME)*100 .."%" )